const float pi = 3.1415926;
const float width = 800;
const float height = 600;
const float inverWidth =1.f/width;
const float inverHeight = 1.f/height;


float square(float a)
{
	return a * a;
}

float wendland(float h, float t){
	float thinvers = t/h;
	return (float(t < h) * square (square(1-thinvers))*(4*thinvers+1));
}


float gaussian(float x, float variance2, float u)
{
	float a = 1.0/sqrt(2 * pi * variance2);
	float b = exp( -square(x-u)/(2*variance2));
	return a * b;
}

/*
float gaussian(float x, float y, float ro)
{
	
	float expon = -(square(x) + square(y))/2/ro/ro;
	float g = 0.5/(pi*ro*ro)* exp(expon);
	return g;
}


float gaussian1(float x, float ro){
	float expon = -square(x)/2/ro/ro;
	float g = 1/(   sqrt(2*pi)*ro)  * exp(expon);
	return g;
}
*/




//blurring filtering


vec4 boxFilter(int steps, sampler2D textureMap)
{
	vec4 sum = vec4(0);
	ivec2 lowPos = ivec2(-steps/2);
    for(int i = 0; i <  steps;++i ){
        float isqr = float(i*i);
        for(int j =  0; j <  steps; ++j ){
        
            ivec2 cordinate = ivec2(gl_FragCoord.xy) + ivec2(i,j) + lowPos;
            vec4 tex = texelFetch(textureMap,cordinate, 0);
            sum += tex;
            
        }
    }
	sum /=(steps * steps); 
	return sum;
}


vec4 gaussianFilter(int steps, sampler2D textureMap, float variance2)
{
	vec4 sum = vec4(0);
	float weightSum = 0;
	//ivec2 lowPos = ivec2(-steps/2);
    for(int i = 0; i <  steps;++i ){
        float isqr = float(i*i);
        for(int j =  0; j <  steps; ++j ){
        
            ivec2 cordinate = ivec2(gl_FragCoord.xy) + ivec2(i,j);// + lowPos;
            vec4 tex = texelFetch(textureMap,cordinate, 0);
			float weight = gaussian( sqrt(float(i*i + j*j))/float(steps), variance2, 0);
            sum += tex * weight;
            weightSum += weight; 
        }
    }
	sum /= weightSum;
	return sum;

}

vec4 wendlandFilter(int steps, sampler2D textureMap)
{
	vec4 sum = vec4(0);
	float weightSum = 0;
	//ivec2 lowPos = ivec2(-steps/2);
    for(int i = 0; i <  steps;++i ){
        float isqr = float(i*i);
        for(int j =  0; j <  steps; ++j ){
        
            ivec2 cordinate = ivec2(gl_FragCoord.xy) + ivec2(i,j); //+ lowPos;
            vec4 tex = texelFetch(textureMap,cordinate, 0);
			float weight = wendland(1, sqrt(float(i*i + j*j))/float(steps));
            sum += tex * weight;
            weightSum += weight; 
        }
    }
	sum /= weightSum;
	return sum;
}

