#version 330 compatibility

uniform sampler2D input;
uniform int steps;

vec4 boxFilter(int steps, sampler2D textureMap)
{
	vec4 sum = vec4(0);
	ivec2 lowPos = ivec2(-steps/2);
    for(int i = 0; i <  steps;++i ){
        float isqr = float(i*i);
        for(int j =  0; j <  steps; ++j ){
        
            ivec2 cordinate = ivec2(gl_FragCoord.xy) + ivec2(i,j) + lowPos;
            vec4 tex = texelFetch(textureMap,cordinate, 0);
            sum += tex;
            
        }
    }
	sum /=(steps * steps); 
	return sum;
}


void main (void) {

    gl_FragColor = boxFilter(steps, input);
    
}

